package info.textgrid.services.aggregator;

import static junit.framework.Assert.assertEquals;
import static junit.framework.Assert.assertNotNull;
import info.textgrid.middleware.confclient.ConfservClientConstants;
import info.textgrid.middleware.tgsearch.client.SearchClient;
import info.textgrid.namespaces.middleware.tgcrud.services.tgcrudservice.TGCrudService;

import org.junit.Test;

public class TEICorpusTest {

	private TEICorpus teicorpus;

	TEICorpus getTeiCorpus() {
		if (teicorpus == null)
			teicorpus = new TEICorpus();
		return teicorpus;
	}

	@Test
	public void testGetConfValue() {
		final String confValue = getTeiCorpus().getConfValue(ConfservClientConstants.TG_SEARCH_PUBLIC);
		assertNotNull("Configuration value is null.", confValue);
		assertEquals("https://textgridlab.org/1.0/tgsearch-public", confValue);
	}

	@Test
	public void testGetCRUDService() {
		final TGCrudService crudService = getTeiCorpus().getCRUDService();
		assertNotNull("TG-crud service is null!?", crudService);
	}

	@Test
	public void testGetSearchClient() {
		final SearchClient searchClient = getTeiCorpus().getSearchClient();
		assertNotNull("TG-search service is null!?", searchClient);
	}


}
